package com.novomind.ecom.app.iagent.core.helloworld.xheader;

import java.security.SecureRandom;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.mail.Message;
import javax.mail.MessagingException;

import org.slf4j.Logger;

import com.novomind.ecom.api.imail.core.CorePlugin;
import com.novomind.ecom.api.imail.core.TemplateMessageManipulator;
import com.novomind.ecom.api.imail.core.result.PreProcessingResult;
import com.novomind.ecom.api.imail.model.IncomingMessageInfo;

@CorePlugin
public class HelloWorldXHeaderIncoming implements TemplateMessageManipulator {

  private static final String X_HEADER = "X-HelloWorld";

  @Inject
  private Logger log;

  private SecureRandom rnd = new SecureRandom();

  @PostConstruct
  public void init() {
    log.debug("init");
  }

  @Override
  public PreProcessingResult preProcess(Message templateMessage, IncomingMessageInfo messageInfo) {
    String i = Integer.toString(rnd.nextInt());
    log.debug("preProcess - adding header \"{}: {}\".", X_HEADER, i);

    try {
      templateMessage.addHeader(X_HEADER, i);
    } catch (MessagingException e) {
      log.warn("Failure adding header \"{}: {}\": ", X_HEADER, i, e);
    }

    return PreProcessingResult.OK;
  }

}